##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate image conversion from JPG, ##
## PNG, GIF, etc. into C-arrays.                                          ##
############################################################################

##
## NEW MACROS
##

## 16 colours palette
PALETTE=0 23 2 3 6 9 11 12 13 15 16 18 20 24 25 26

## Default values
#$(eval $(call IMG2SP, SET_MODE        , 0                  ))  { 0, 1, 2 }
#$(eval $(call IMG2SP, SET_MASK        , none               ))  { interlaced, none }
#$(eval $(call IMG2SP, SET_FOLDER      , src/               ))
#$(eval $(call IMG2SP, SET_EXTRAPAR    ,                    ))
#$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites            ))	{ sprites, zgtiles, screen }
#$(eval $(call IMG2SP, SET_OUTPUT      , c                  ))  { bin, c }
#$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
#$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))
#$(eval $(call IMG2SP, CONVERT         , img.png , w, h, array, palette, tileset))
$(eval $(call IMG2SP, SET_MODE         , 0                  ))
$(eval $(call IMG2SP, SET_FOLDER       , src/sprites/converted ))
$(eval $(call IMG2SP, SET_OUTPUT       , c                  ))
$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))
### PLAYER
$(eval $(call IMG2SP, CONVERT          , assets/Naves_I.jpg , 16, 13, spr_playership))
### BULLETS
$(eval $(call IMG2SP, CONVERT          , assets/Balas_I.png , 4, 8, spr_bullet1))
$(eval $(call IMG2SP, CONVERT          , assets/Bala_Enemigo.jpg , 6, 9, spr_bullet_enemy1))
### ENEMIES
$(eval $(call IMG2SP, CONVERT          , assets/Marcianos_I.png , 8, 14, spr_enemy1))
$(eval $(call IMG2SP, CONVERT          , assets/Alien_V.png , 14, 13, spr_enemy2))
$(eval $(call IMG2SP, CONVERT          , assets/Alien_III.png , 14, 13, spr_enemy3))
$(eval $(call IMG2SP, CONVERT          , assets/Marcianos_II.png , 16, 14, spr_enemy4))
$(eval $(call IMG2SP, CONVERT          , assets/Alien_IV.png , 14, 14, spr_enemy5))
$(eval $(call IMG2SP, CONVERT          , assets/barrier.png , 16, 6, spr_enemy_barrier))
$(eval $(call IMG2SP, CONVERT          , assets/crawler.png , 14, 12, spr_enemy_crawler))
$(eval $(call IMG2SP, CONVERT          , assets/stalker.png , 10, 13, spr_enemy_stalker))
$(eval $(call IMG2SP, CONVERT          , assets/enemycore.png , 8, 8, spr_enemy_core))
$(eval $(call IMG2SP, CONVERT          , assets/enemyflag.png , 8, 8, spr_enemy_flag))
### POWERUPS
$(eval $(call IMG2SP, CONVERT          , assets/LifeUp.png , 12, 15, spr_pw_extra_life))
$(eval $(call IMG2SP, CONVERT          , assets/Shoot_Up.jpg , 12, 11, spr_pw_wpn_upgrade))
$(eval $(call IMG2SP, CONVERT          , assets/points_anim.png , 8, 14, spr_pw_points))
$(eval $(call IMG2SP, CONVERT          , assets/kill_all.png , 14, 13, spr_pw_bomb))
$(eval $(call IMG2SP, CONVERT          , assets/popref.png , 8, 14, spr_pw_persia))
### HUD ITEMS
$(eval $(call IMG2SP, CONVERT          , assets/Lifes_X.jpg , 22, 8, spr_lifecount_icon))
$(eval $(call IMG2SP, CONVERT          , assets/Numbers_6x7.png , 6, 7, spr_lifecount))
$(eval $(call IMG2SP, CONVERT          , assets/hud_bg.png, 0, 0, spr_hud_bg))
$(eval $(call IMG2SP, CONVERT          , assets/menus/pausemenu.png , 0, 0, spr_pausemenu))
$(eval $(call IMG2SP, CONVERT          , assets/topscore.png , 0, 0, spr_topscore))
### TITLES
$(eval $(call IMG2SP, CONVERT          , assets/Level_I.jpg , 48, 8, spr_level_1_title))
$(eval $(call IMG2SP, CONVERT          , assets/Level_II.jpg , 48, 8, spr_level_2_title))
$(eval $(call IMG2SP, CONVERT          , assets/Level_III.jpg , 48, 8, spr_level_3_title))
$(eval $(call IMG2SP, CONVERT          , assets/Level_IV.jpg , 48, 8, spr_level_4_title))
$(eval $(call IMG2SP, CONVERT          , assets/Level_V.jpg , 48, 8, spr_level_5_title))
$(eval $(call IMG2SP, CONVERT          , assets/Level_VI.jpg , 48, 8, spr_level_6_title))
$(eval $(call IMG2SP, CONVERT          , assets/Level_VII.jpg , 48, 8, spr_level_7_title))
$(eval $(call IMG2SP, CONVERT          , assets/Level_VIII.jpg , 48, 8, spr_level_8_title))
$(eval $(call IMG2SP, CONVERT          , assets/Level_IX.jpg , 48, 8, spr_level_9_title))
$(eval $(call IMG2SP, CONVERT          , assets/Level_X.jpg , 0, 0, spr_level_10_title))
$(eval $(call IMG2SP, CONVERT          , assets/Level_XI.jpg , 0, 0, spr_level_11_title))
$(eval $(call IMG2SP, CONVERT          , assets/Level_XII.jpg , 0, 0, spr_level_12_title))
$(eval $(call IMG2SP, CONVERT          , assets/Level_XIII.jpg , 0, 0, spr_level_13_title))
$(eval $(call IMG2SP, CONVERT          , assets/Warning.jpg , 72, 8, spr_warning_title))
$(eval $(call IMG2SP, CONVERT          , assets/cell_title.png , 0, 0, spr_cell_title))
$(eval $(call IMG2SP, CONVERT          , assets/core_title.png , 0, 0, spr_core_title))

### EXPLOSIONS
$(eval $(call IMG2SP, CONVERT          , assets/Explosion_S.png , 6, 6, spr_explosion_s))
$(eval $(call IMG2SP, CONVERT          , assets/explosion_mm.png , 8, 8, spr_explosion_mm))
$(eval $(call IMG2SP, CONVERT          , assets/Explosion_M.jpg , 12, 12, spr_explosion_m))
### STARS
$(eval $(call IMG2SP, CONVERT          , assets/Stars.png , 2, 1, spr_star))
### MENUS
$(eval $(call IMG2SP, SET_FOLDER       , src/sprites/binary ))
$(eval $(call IMG2SP, SET_IMG_FORMAT   , screen ))
$(eval $(call IMG2SP, SET_OUTPUT       , bin ))
$(eval $(call IMG2SP, CONVERT          , assets/menus/mainmenu.png , 0, 0, sprmainmenu))
$(eval $(call IMG2SP, CONVERT          , assets/menus/controlsmenu.png , 0, 0, sprcontrolsmenu))
$(eval $(call IMG2SP, CONVERT          , assets/menus/creditsmenu.png , 0, 0, sprcreditsmenu))
$(eval $(call IMG2SP, CONVERT          , assets/menus/gameover.png , 0, 0, sprgameover))
$(eval $(call IMG2SP, CONVERT          , assets/menus/winscreen.png , 0, 0, sprwin))
$(eval $(call IMG2SP, CONVERT          , assets/menus/introscreen.png , 0, 0, sprintro))

##
## OLD MACROS (For compatibility)
##

## Example firmware palette definition as variable in cpct_img2tileset format

# PALETTE={0 1 3 4 7 9 10 12 13 16 19 20 21 24 25 26}

## AUTOMATED IMAGE CONVERSION EXAMPLE (Uncomment EVAL line to use)
##
##    This example would convert img/example.png into src/example.{c|h} files.
##    A C-array called pre_example[24*12*2] would be generated with the definition
##    of the image example.png in mode 0 screen pixel format, with interlaced mask.
##    The palette used for conversion is given through the PALETTE variable and
##    a pre_palette[16] array will be generated with the 16 palette colours as 
##	  hardware colour values.

#$(eval $(call IMG2SPRITES,img/example.png,0,pre,24,12,$(PALETTE),mask,src/,hwpalette))



############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macro used for conversion is IMG2SPRITES, which has up to 9 parameters:##
##  (1): Image file to be converted into C sprite (PNG, JPG, GIF, etc)    ##
##  (2): Graphics mode (0,1,2) for the generated C sprite                 ##
##  (3): Prefix to add to all C-identifiers generated                     ##
##  (4): Width in pixels of each sprite/tile/etc that will be generated   ##
##  (5): Height in pixels of each sprite/tile/etc that will be generated  ##
##  (6): Firmware palette used to convert the image file into C values    ##
##  (7): (mask / tileset / zgtiles)                                       ##
##     - "mask":    generate interlaced mask for all sprites converted    ##
##     - "tileset": generate a tileset array with pointers to all sprites ##
##     - "zgtiles": generate tiles/sprites in Zig-Zag pixel order and     ##
##                  Gray Code row order                                   ##
##  (8): Output subfolder for generated .C/.H files (in project folder)   ##
##  (9): (hwpalette)                                                      ##
##     - "hwpalette": output palette array with hardware colour values    ##
## (10): Aditional options (you can use this to pass aditional modifiers  ##
##       to cpct_img2tileset)                                             ##
##                                                                        ##
## Macro is used in this way (one line for each image to be converted):   ##
##  $(eval $(call IMG2SPRITES,(1),(2),(3),(4),(5),(6),(7),(8),(9), (10))) ##
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/sprites,... will represent "src/sprites"   ##
##    folder, whereas ...,  src/sprites,... means "  src/sprites" folder. ##
##                                                                        ##
##  * You can omit parameters but leaving them empty. Therefore, if you   ##
##  wanted to specify an output folder but do not want your sprites to    ##
##  have mask and/or tileset, you may omit parameter (7) leaving it empty ##
##     $(eval $(call IMG2SPRITES,imgs/1.png,0,g,4,8,$(PAL),,src/))        ##
############################################################################
