;======================= LICENSE NOTICE =================================
;This file is part of HyperSpace, a videogame for Amstrad CPC 464.
;Copyright (C) 2020 HardBytes
;
;    HyperSpace is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    HyperSpace is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with HyperSpace.  If not, see <https://www.gnu.org/licenses/>.
;========================================================================   

.module Manager_Hud_Items

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; CONSTANTS                                                        ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; Hud properties
hud_type        = 0
hud_comps       = 1
hud_x_pos       = 2
hud_y_pos       = 3
hud_spr_w       = 4
hud_spr_h       = 5
hud_sprite      = 6  ;; 2 bytes
hud_anim        = 8  ;; 2 bytes
hud_anim_count  = 10
hud_prev_render = 11 ;; 2 bytes
hud_prev_prev_render = 13 ;; 2 bytes

;;; Hud data
hud_item_size   = 15
hud_max_count   = 24
hud_array_byte_size = hud_item_size*hud_max_count

;;; Hud item type masks
hud_type_invalid        = 0x00
hud_type_placeholder    = 0x01
hud_type_lifebar        = 0x02
hud_type_score          = 0x04
hud_type_title          = 0x08
hud_type_bossbar        = 0x10
hud_type_pause          = 0x20
hud_type_dead           = 0x80
hud_type_default        = hud_type_title

;; Hud Item Components
hud_comp_redraw1        = 0x01  ;; Used to indicate if it should be drawn in the next frame
hud_comp_redraw2        = 0x02  ;; Used to indicate if it should be drawn in the next's next frame
hud_comp_redraw3        = 0x04  ;; Used to indicate if it should be drawn in the next's next frame
hud_comp_alwaysdraw     = 0x08  ;; Used to indicate if this is rendered every frame or only first time
hud_comp_animated       = 0x10

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ROUTINES                                                         ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.globl man_create_one_hud_item
.globl man_destroy_one_hud_item
.globl man_mark_hud_item_for_destruction
.globl man_mark_for_destroy_hud_of_type
.globl man_update_dead_hud_items
.globl man_hud_for_all
.globl man_hud_search_type
.globl man_empty_hud
