;======================= LICENSE NOTICE =================================
;This file is part of HyperSpace, a videogame for Amstrad CPC 464.
;Copyright (C) 2020 HardBytes
;
;    HyperSpace is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    HyperSpace is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with HyperSpace.  If not, see <https://www.gnu.org/licenses/>.
;========================================================================   

.module Sprites_Module

;; Player
.globl _spr_playership_0
.globl _spr_playership_1
spr_playership_w = 8
spr_playership_h = 13

.globl _spr_explosion_s_0
.globl _spr_explosion_s_1
.globl _spr_explosion_s_2
.globl _spr_explosion_s_3
spr_explosion_s_w = 3
spr_explosion_s_h = 6

.globl _spr_explosion_mm_0
.globl _spr_explosion_mm_1
.globl _spr_explosion_mm_2
.globl _spr_explosion_mm_3
spr_explosion_mm_w = 4
spr_explosion_mm_h = 8

.globl _spr_explosion_m_0
.globl _spr_explosion_m_1
.globl _spr_explosion_m_2
.globl _spr_explosion_m_3
.globl _spr_explosion_m_4
.globl _spr_explosion_m_5
.globl _spr_explosion_m_6
.globl _spr_explosion_m_7
spr_explosion_m_w = 6
spr_explosion_m_h = 12

;; Bullets
.globl _spr_bullet1_0
.globl _spr_bullet1_1
.globl _spr_bullet1_2
spr_bullet_w = 2
spr_bullet_h = 8
.globl _spr_bullet_enemy1_0
.globl _spr_bullet_enemy1_1
.globl _spr_bullet_enemy1_2
spr_enemy_bullet_w = 3
spr_enemy_bullet_h = 9

;; Enemies
.globl _spr_enemy1_0
.globl _spr_enemy1_1
.globl _spr_enemy1_2
spr_enemy1_w = 4
spr_enemy1_h = 14

.globl _spr_enemy2_0
.globl _spr_enemy2_1
.globl _spr_enemy2_2
spr_enemy2_w = 7
spr_enemy2_h = 13

.globl _spr_enemy3_0
.globl _spr_enemy3_1
.globl _spr_enemy3_2
spr_enemy3_w = 7
spr_enemy3_h = 13

.globl _spr_enemy4_0
.globl _spr_enemy4_1
spr_enemy4_w = 8
spr_enemy4_h = 14

.globl _spr_enemy5_0
.globl _spr_enemy5_1
.globl _spr_enemy5_2
spr_enemy5_w = 7
spr_enemy5_h = 14

.globl _spr_enemy_barrier_0
.globl _spr_enemy_barrier_1
.globl _spr_enemy_barrier_2
spr_enemy_barrier_w = 8
spr_enemy_barrier_h = 6

.globl _spr_enemy_crawler_0
.globl _spr_enemy_crawler_1
.globl _spr_enemy_crawler_2
spr_enemy_crawler_w = 7
spr_enemy_crawler_h = 12

.globl _spr_enemy_stalker_0
.globl _spr_enemy_stalker_1
.globl _spr_enemy_stalker_2
spr_enemy_stalker_w = 5
spr_enemy_stalker_h = 13

.globl _spr_enemy_core_0
.globl _spr_enemy_core_1
.globl _spr_enemy_core_2
spr_enemy_core_w = 4
spr_enemy_core_h = 8

.globl _spr_enemy_flag_0
.globl _spr_enemy_flag_1
spr_enemy_flag_w = 4
spr_enemy_flag_h = 8

;; Power-ups
.globl _spr_pw_extra_life
spr_pw_extra_life_w = 6
spr_pw_extra_life_h = 15

.globl _spr_pw_wpn_upgrade_0
.globl _spr_pw_wpn_upgrade_1
.globl _spr_pw_wpn_upgrade_2
spr_pw_wpn_upgrade_w = 6
spr_pw_wpn_upgrade_h = 11

.globl _spr_pw_points_0
.globl _spr_pw_points_1
.globl _spr_pw_points_2
spr_pw_points_w = 4
spr_pw_points_h = 14

.globl _spr_pw_bomb_0
.globl _spr_pw_bomb_1
.globl _spr_pw_bomb_2
.globl _spr_pw_bomb_3
spr_pw_bomb_w = 7
spr_pw_bomb_h = 13

.globl _spr_pw_persia_0
.globl _spr_pw_persia_1
.globl _spr_pw_persia_2
.globl _spr_pw_persia_3
spr_pw_persia_w = 4
spr_pw_persia_h = 14

;; HUD Items
.globl _spr_lifecount_icon
spr_lifecount_icon_w = 11
spr_lifecount_icon_h = 8
.globl _spr_lifecount_00
.globl _spr_lifecount_01
.globl _spr_lifecount_02
.globl _spr_lifecount_03
.globl _spr_lifecount_04
.globl _spr_lifecount_05
.globl _spr_lifecount_06
.globl _spr_lifecount_07
.globl _spr_lifecount_08
.globl _spr_lifecount_09
spr_lifecount_w = 3
spr_lifecount_h = 7

.globl _spr_hud_bg
spr_hud_bg_w = 29
spr_hud_bg_h = 8

.globl _spr_pausemenu
spr_pausemenu_w = 16
spr_pausemenu_h = 22

.globl _spr_topscore
spr_topscore_w = 3
spr_topscore_h = 5

;; Level titles
.globl _spr_level_1_title
.globl _spr_level_2_title
.globl _spr_level_3_title
.globl _spr_level_4_title
.globl _spr_level_5_title
.globl _spr_level_6_title
.globl _spr_level_7_title
.globl _spr_level_8_title
.globl _spr_level_9_title
spr_1digit_title_w = 24
spr_1digit_title_h = 8
.globl _spr_level_10_title
.globl _spr_level_11_title
.globl _spr_level_12_title
.globl _spr_level_13_title
spr_2digit_title_w = 28
spr_2digit_title_h = 8

.globl _spr_warning_title_0
.globl _spr_warning_title_1
.globl _spr_warning_title_2
.globl _spr_warning_title_3
spr_warning_title_w = 36
spr_warning_title_h = 8

;;boss titles
.globl _spr_cell_title
spr_cell_title_w = 36
spr_cell_title_h = 5
.globl _spr_core_title
spr_core_title_w = 32
spr_core_title_h = 5
;; Stars
.globl _spr_star_0
.globl _spr_star_1
.globl _spr_star_2
.globl _spr_star_3
spr_star_w = 1
spr_star_h = 1

