;======================= LICENSE NOTICE =================================
;This file is part of HyperSpace, a videogame for Amstrad CPC 464.
;Copyright (C) 2020 HardBytes
;
;    HyperSpace is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    HyperSpace is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with HyperSpace.  If not, see <https://www.gnu.org/licenses/>.
;========================================================================    

.module System_Audio

;;;;;;;;;;;;;;;;;;;;;;
;; ROUTINES         ;;
;;;;;;;;;;;;;;;;;;;;;;
.globl is_muted

.globl sys_audio_check_mute

.globl sys_audio_init_sfx
.globl sys_audio_init_menu_music
.globl sys_audio_init_game_music
.globl sys_audio_init_intro_music
.globl sys_audio_init_win_music

.globl sys_audio_play_sfx_playershoot
.globl sys_audio_play_sfx_explosion
.globl sys_audio_play_sfx_big_explosion

;.globl sys_audio_test_sfx_loop

;;;;;;;;;;;;;;;;;;;;;;
;; CONSTANTS        ;;
;;;;;;;;;;;;;;;;;;;;;;
key_mute = 0x4004   ;; M = Bit 6 (0x40), Line 4

;;;;;;;;;;;;;;;;;;;;;;
;; MACROS           ;;
;;;;;;;;;;;;;;;;;;;;;;
.macro check_mute
    ld a, (is_muted)
    or a
    ret z
.endm
