;======================= LICENSE NOTICE =================================
;This file is part of HyperSpace, a videogame for Amstrad CPC 464.
;Copyright (C) 2020 HardBytes
;
;    HyperSpace is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    HyperSpace is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with HyperSpace.  If not, see <https://www.gnu.org/licenses/>.
;========================================================================   

.module System_Input

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; CONSTANTS                                                        ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
keyb_key    = 0
keyb_action = 2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; KEY BINDINGS                                                     ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

keyid_esc       = 0x0408   ;; Esx   = Bit 2 (0x04), Line 8
keyid_x         = 0x8007   ;; X     = Bit 7 (0x80), Line 7

keyid_p         = 0x0803   ;; P     = Bit 3 (0x08), Line 3
keyid_o         = 0x0404   ;; O     = Bit 2 (0x04), Line 4
keyid_a         = 0x2008   ;; A     = Bit 5 (0x20), Line 8
keyid_q         = 0x0808   ;; Q     = Bit 3 (0x08), Line 8

keyid_d         = 0x2007   ;; D     = Bit 5 (0x20), Line 7
keyid_a         = 0x2008   ;; A     = Bit 5 (0x20), Line 8
keyid_s         = 0x1007   ;; S     = Bit 4 (0x10), Line 7
keyid_w         = 0x0807   ;; W     = Bit 3 (0x08), Line 7

keyid_j_right   = 0x0809   ;; JoyR  = Bit 3 (0x08), Line 9
keyid_j_left    = 0x0409   ;; JoyL  = Bit 2 (0x04), Line 9
keyid_j_down    = 0x0209   ;; JoyD  = Bit 1 (0x02), Line 9
keyid_j_up      = 0x0109   ;; JoyU  = Bit 0 (0x01), Line 9

keyid_j_fire1   = 0x1009   ;; JoyF1 = Bit 4 (0x10), Line 9
keyid_space     = 0x8005   ;; Space = Bit 7 (0x80), Line 5

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ROUTINES                                                         ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.globl sys_input_check
.globl sys_input_keybindings_default
.globl sys_input_keybindings_alternative
.globl sys_input_switch_keybindings
.globl sys_input_get_status

.globl sys_input_check_pressed_once
