;======================= LICENSE NOTICE =================================
;This file is part of HyperSpace, a videogame for Amstrad CPC 464.
;Copyright (C) 2020 HardBytes
;
;    HyperSpace is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    HyperSpace is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with HyperSpace.  If not, see <https://www.gnu.org/licenses/>.
;========================================================================   

.module System_Score

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; CONSTANTS                    ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
score_digits = 3
score_string_x_start = 22
end_game_score_string_x_start = 31
mainmenu_score_string_x_start = 32
end_game_score_string_y = 90
win_game_score_string_y = 141
mainmenu_hiscore_string_y = 61
win_game_hiscore_string_y = 119

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ROUTINES                     ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.globl sys_score_init
.globl sys_score_add
.globl sys_score_get_number_sprite

.globl sys_score_create
.globl sys_score_draw
.globl sys_score_win_game_draw
.globl sys_score_end_game_draw
.globl sys_score_hiscore_mainmenu_draw
.globl sys_score_hiscore_wingame_draw

.globl sys_score_create_top_mark
.globl check_hi_score_reached

.globl sys_score_save_score_state
.globl sys_score_load_score_state
.globl sys_score_check_save_hiscore
