;======================= LICENSE NOTICE =================================
;This file is part of HyperSpace, a videogame for Amstrad CPC 464.
;Copyright (C) 2020 HardBytes
;
;    HyperSpace is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    HyperSpace is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with HyperSpace.  If not, see <https://www.gnu.org/licenses/>.
;========================================================================    

.include "../templates.h.s"
.include "../../manager/entities.h.s"
.include "../../manager/bullet.h.s"
.include "../../sprites/sprites.h.s"
.include "../../animations/animations.h.s"
.include "../../system/ai.h.s"
.include "../../system/death_behaviours.h.s"

ent_template_enemy_core::
.db #ent_type_enemy     ;; Type
.db 0b00111011          ;; Components (Render, move, AI, Collider, Animated)
.db 0, 0                ;; X and Y position
.db 0, 1                ;; X and Y speed
.db #spr_enemy_core_w   ;; Sprite Width
.db #spr_enemy_core_h   ;; Sprite Height
.dw #_spr_enemy_core_0  ;; Sprite
.dw #sys_ai_behaviour_patrol;; AI Behaviour routine
.db 0, 30               ;; AI Counters
.db 0b00000100          ;; Collision Mask (Bullets)
.db 20                  ;; Base Health
.db 0x20                ;; Points (Divided by 100, and BCD, decimal value in hexadecimal format) -> 0x01 = 100pts, 0x10 = 1000pts
.dw #anim_enemy_core    ;; Animation
.db 10                  ;; Animation Counter
.dw #sys_death_boss_core;; Death Behaviour
.dw #man_bullet_enemy_basic_atk;; Attack pattern
.dw 0xC040              ;; Previous video memory position
.dw 0xC040              ;; Previous of the previous video memory position
.dw 0000, 0000                      ;; Set offset

