;======================= LICENSE NOTICE =================================
;This file is part of HyperSpace, a videogame for Amstrad CPC 464.
;Copyright (C) 2020 HardBytes
;
;    HyperSpace is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    HyperSpace is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with HyperSpace.  If not, see <https://www.gnu.org/licenses/>.
;========================================================================    

.include "../templates.h.s"
.include "../../manager/entities.h.s"
.include "../../manager/bullet.h.s"
.include "../../sprites/sprites.h.s"
.include "../../animations/animations.h.s"
.include "../../system/ai.h.s"
.include "../../system/death_behaviours.h.s"

ent_template_enemy_patroller::
.db #ent_type_enemy     ;; Type
.db 0b00111011          ;; Components (Render, move, AI, Collider, Animated)
.db 0, 0                ;; X and Y position
.db 0, 1                ;; X and Y speed
.db #spr_enemy5_w       ;; Sprite Width
.db #spr_enemy5_h       ;; Sprite Height
.dw #_spr_enemy5_0      ;; Sprite
.dw #sys_ai_behaviour_patrol;; AI Behaviour routine
.db 1, 40               ;; AI Counters (Start moving in X at 1 speed, Stop Y movement at 40)
.db 0b00000101          ;; Collision Mask (Bullets)
.db 4                   ;; Base Health
.db 0x04                ;; Points (Divided by 100, and BCD, decimal value in hexadecimal format)
.dw #anim_enemy_patroller;; Animation
.db 10                  ;; Animation Counter
.dw #sys_death_mid_explode;; Death Behaviour
.dw #man_bullet_enemy_basic_atk;; Attack pattern
.dw 0xC040              ;; Previous video memory position
.dw 0xC040              ;; Previous of the previous video memory position
.dw 0000, 0000                      ;; Set offset

