;======================= LICENSE NOTICE =================================
;This file is part of HyperSpace, a videogame for Amstrad CPC 464.
;Copyright (C) 2020 HardBytes
;
;    HyperSpace is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    HyperSpace is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with HyperSpace.  If not, see <https://www.gnu.org/licenses/>.
;========================================================================    

.include "../templates.h.s"
.include "../../manager/bullet.h.s"
.include "../../sprites/sprites.h.s"
.include "../../animations/animations.h.s"
.include "../../system/ai.h.s"
.include "../../system/death_behaviours.h.s"


ent_template_player::
.db 0x01                ;; Type (Player)
.db 0b00110111          ;; Components (Render, move, Input, Collider, Animated)
.db 16, 100             ;; X and Y position
.db 0x00, 0x00          ;; X and Y speed
.db #spr_playership_w   ;; Sprite Width
.db #spr_playership_h   ;; Sprite Height
.dw #_spr_playership_0   ;; Sprite
.dw 0x0000              ;; AI Behaviour routine
.db 0,0                 ;; AI Counters
.db 0b00001010          ;; Collision Mask (Enemies, Enemy bullets)
.db 1                   ;; Base Health
.db 0x00                ;; Points (Divided by 100, and BCD, decimal value in hexadecimal format)
.dw #anim_playership_center ;; Animation
.db 1                   ;; Animation Counter
.dw #sys_death_player_death;; Death Behaviour
.dw #man_bullet_player_lvl1 ;; Attack pattern
.dw 0xC040              ;; Previous video memory position
.dw 0xC040              ;; Previous of the previous video memory position
.dw 0000, 0000                      ;; Set offset
