;======================= LICENSE NOTICE =================================
;This file is part of HyperSpace, a videogame for Amstrad CPC 464.
;Copyright (C) 2020 HardBytes
;
;    HyperSpace is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    HyperSpace is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with HyperSpace.  If not, see <https://www.gnu.org/licenses/>.
;========================================================================    

.include "../templates.h.s"
.include "../../manager/entities.h.s"
.include "../../sprites/sprites.h.s"
.include "../../system/ai.h.s"
.include "../../system/death_behaviours.h.s"

ent_template_star0::
.db #ent_type_bullet    ;; Type
.db 0b00001011          ;; Components (Render, Move, AI)
.db 0, 0                ;; X and Y position
.db 0, 4                ;; X and Y speed
.db #spr_star_w         ;; Sprite Width
.db #spr_star_h         ;; Sprite Height
.dw #_spr_star_0        ;; Sprite
.dw #sys_ai_behaviour_star;; AI Behaviour routine
.db 40, 1               ;; AI Counters
.db 0                   ;; Collision Mask (None)
.db 1                   ;; Base Health
.db 0x00                ;; Points (Divided by 100, and BCD, decimal value in hexadecimal format)
.dw 0                   ;; Animation
.db 1                   ;; Animation Counter
.dw #sys_death_donothing;; Death Behaviour
.dw 0                   ;; Attack pattern
.dw 0xC040              ;; Previous video memory position
.dw 0xC040              ;; Previous of the previous video memory position
.dw 0000, 0000                      ;; Set offset

